<template>
  <svn-modal-skeleton
    :modal-title="title"
    :persistent="persistent"
    :activator-text="activatorText"
    :modal-title-center="modalTitleCenter"
    :vertical="vertical"
    :vertical-header="verticalHeader"
    :prepend-header-icon="prependHeaderIcon"
    :append-header-icon="appendHeaderIcon"
    :header-custom-class="headerCustomClass"
    :modal-custom-class="modalCustomClass"
    :activator-variant="activatorVariant"
  >
    <template #activator>
      <slot name="activator" />
    </template>

    <template #content-body>
      <div class="flex flex-col gap-2">
        <svn-auto-complete-dropdown class="text-black p-3" :persistent="true" @input="customSearch">
          <template #dropdown>
            <v-list v-if="searchUsers?.length" class="shadow overflow-auto max-h-60">
              <v-list-item
                v-for="user in searchUsers"
                :key="user.id"
                class="w-100 text-start px-2 sm:!px-4"
                @click="userIsAdded(user) ? '' : addUser(user.id)"
              >
                <template #prepend>
                  <svn-avatar
                    size="md"
                    :image="user?.avatar || user?.avatar?.['30']"
                    :firstname="user?.firstname"
                    :lastname="user?.lastname"
                  />
                </template>
  
                <v-list-item-title>
                  {{ user?.fullname }}
                </v-list-item-title>
  
                <template #append>
                  <v-btn
                    v-if="userIsAdded(user)"
                    color="positiveGreen"
                    variant="text"
                    class="!normal-case"
                  >
                    <Icon
                      icon="mdi-check"
                      height="16"
                      width="16"
                      class="mr-2"
                    />
                    {{ ("Added") }}
                  </v-btn>
  
                  <v-btn
                    v-else
                    color="primary"
                    variant="text"
                    class="!normal-case"
                  >
                    <Icon
                      icon="mdi-add"
                      height="16"
                      width="16"
                      class="mr-2"
                    />
                    {{ ("Add") }}
                  </v-btn>
                </template>
              </v-list-item>
            </v-list>

            <div
              v-else
              class="w-2/3 flex flex-col justify-center items-center text-center mt-2 h-28 mx-auto"
            >
              <span class="font-normal text-base text-dark-grey">
                {{ "Hmm, It seems there is no user matching your search, please try again." }}
              </span>
            </div>
          </template>
  
          <template #dropdown-additional="{ search }">
            <v-btn
              v-if="searchUsers?.length === 5"
              class="z-10 w-full bg-neutral-400 rounded-none text-white font-medium"
              @click="customSearch(search, 0)"
            >
              {{ 'Display all users...' }}
            </v-btn>
  
            <v-btn
              v-if="searchUsers.length === 0"
              class="z-10 w-full bg-red-400 rounded-none text-white font-medium"
            >
              {{ 'No user found, please try again !' }}
            </v-btn>
          </template>
        </svn-auto-complete-dropdown>
  
        <div
          v-if="listUsers?.length"
          class="overflow-auto max-h-[375px]"
        >
          <v-list-item
            v-for="(user, idx) in listUsers?.filter(el => el.id !== 0)"
            :key="idx"
            class="py-2 hover:bg-very-light-grey active:bg-light-grey cursor-pointer"
          >
            <div class="w-full flex items-center">
              <svn-avatar
                :avatar="user?.avatar || user?.avatar?.['30']"
                :firstname="user?.firstname"
                :lastname="user?.lastname"
                size="md"
                class="rounded-full mr-2"
              />
  
              <span>
                {{ user?.fullname }}
              </span>
  
              <v-spacer />
  
              <v-btn
                color="error"
                class="!normal-case"
                variant="text"
                @click="removeUser(user?.id)"
              >
                {{ "Remove" }}
              </v-btn>
            </div>
          </v-list-item>
        </div>
  
        <div
          v-else
          class="w-2/3 flex flex-col justify-center items-center text-center mt-2 h-96 mx-auto pb-10"
        >
          <Icon
            icon="noto:busts-in-silhouette"
            height="40"
            class="mx-auto mb-3"
          />
  
          <span class="font-medium text-md">
            {{ "Hmm, It seems there is no users selected, search for users and add them." }}
          </span>
        </div>
      </div>
    </template>
  </svn-modal-skeleton>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import SvnAvatar from '../avatar/SvnAvatar.vue';
import SvnModalSkeleton from '../skeleton/SvnModalSkeleton.vue';
import SvnAutoCompleteDropdown from '../SvnAutoCompleteDropdown.vue';

const props = defineProps({
  title: { type: String, default: 'Manage trainers' },
  searchUsers: { type: Array, default: () => [] },
  listUsers: { type: Array, default: () => [] },
  persistent: { type: Boolean, default: false },
  activatorText: { type: String, default: 'Open modal' },
  modalTitleCenter: { type: Boolean, default: false },
  vertical: { type: Boolean, default: false },
  verticalHeader: { type: Boolean, default: false },
  prependHeaderIcon: { type: String, default: '' },
  appendHeaderIcon: { type: String, default: 'mdi:close' },
  appendIconCloseModal: { type: Boolean, default: false },
  headerCustomClass: { type: String, default: '' },
  modalCustomClass: { type: String, default: '' },
  activatorVariant: { type: String, default: 'default' },
})

const emit = defineEmits(['add-user', 'remove-user', 'custom-search'])

const addUser = (userId) => {
  emit('add-user', userId)
}

const removeUser = (userId) => {
  emit('remove-user', userId)
}

const customSearch = (search, limit) => {
  emit('custom-search', search, limit)
}

const userIsAdded = (user) => {
  const found = props?.listUsers.find((element) => element?.id === user?.id)
  return found ? true : false
}
</script>

<style scoped>
.shadow {
  box-shadow: 0px 2px 4px 0px rgba(0, 0, 0, 0.25);
}
</style>